org.apache.commons.io.input

## Class AutoCloseInputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - org.apache.commons.io.input.ProxyInputStream
      - - org.apache.commons.io.input.AutoCloseInputStream

All Implemented Interfaces:
  Closeable, AutoCloseable

    public class AutoCloseInputStream
    extends ProxyInputStream

Proxy stream that closes and discards the underlying stream as soon as the end of input has been reached or when the stream is explicitly closed. Not even a reference to the underlying stream is kept after it has been closed, so any allocated in-memory buffers can be freed even if the client application still keeps a reference to the proxy stream.

This class is typically used to release any resources related to an open stream as soon as possible even if the client application (by not explicitly closing the stream when no longer needed) or the underlying stream (by not releasing resources once the last byte has been read) do not do that.

Since:
  1.4

### Field Summary

### Fields inherited from class java.io.FilterInputStream

`in`

### Constructor Summary

Constructors
Constructor and Description
`AutoCloseInputStream(InputStream in)` Creates an automatically closing proxy for the given input stream.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `afterRead(int n)` Automatically closes the stream if the end of stream was reached.
`void` `close()` Closes the underlying input stream and replaces the reference to it with a `ClosedInputStream` instance.
`protected void` `finalize()` Ensures that the stream is closed before it gets garbage-collected.

### Methods inherited from class org.apache.commons.io.input.ProxyInputStream

`available, beforeRead, handleIOException, mark, markSupported, read, read, read, reset, skip`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AutoCloseInputStream

    public AutoCloseInputStream(InputStream in)

Creates an automatically closing proxy for the given input stream.

Parameters:
  `in` - underlying input stream

### Method Detail

#### close

    public void close()
               throws IOException

Closes the underlying input stream and replaces the reference to it with a `ClosedInputStream` instance.

This method is automatically called by the read methods when the end of input has been reached.

Note that it is safe to call this method any number of times. The original underlying input stream is closed and discarded only once when this method is first called.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Overrides:
  `close` in class `ProxyInputStream`
Throws:
  `IOException` - if the underlying input stream can not be closed

#### afterRead

    protected void afterRead(int n)
                      throws IOException

Automatically closes the stream if the end of stream was reached.

Overrides:
  `afterRead` in class `ProxyInputStream`
Parameters:
  `n` - number of bytes read, or -1 if no more bytes are available
Throws:
  `IOException` - if the stream could not be closed
Since:
  2.0

#### finalize

    protected void finalize()
                     throws Throwable

Ensures that the stream is closed before it gets garbage-collected. As mentioned in `close()`, this is a no-op if the stream has already been closed.

Overrides:
  `finalize` in class `Object`
Throws:
  `Throwable` - if an error occurs